signature DeflateBits =
sig

	(*
	 convert boolean to integer or character
	*)
	
	val bit_to_int : bool -> int
	
	val bit_to_char : bool -> char
	
	(*
	 convert integer into list of boolean, lsb or msb first
	 int : number of bits in result
	 int : integer to convert
	 bool list : result
	*)
	
	val explode_fixed_lsb_first : int -> int -> bool list
	
	val explode_fixed_msb_first : int -> int -> bool list

	(*
	 convert list of boolean to integer, lsb or msb first
	*)
	
	val to_int_lsb_first : bool list -> int
	
	val to_int_msb_first : bool list -> int
	
	val to_string : bool list -> string
	
	(*
	 misc
	*)
	
	val pow2 : int -> int
	
	(*
	 bit/byteIO stream
	*)
	
	type byteio
	
	(* constructor *)
	
	val from_input : int list -> byteio
	
	(* debug *)
	
	val io_to_string : byteio -> string
	
	(* make one more byte into bits *)
	 
	val forth : byteio -> byteio
	
	(* output *)
	
	val output : byteio -> int list
	
	val append_from_output : byteio -> int -> int -> byteio
	
	val append_byte : byteio -> int -> byteio
	
	val append_bytes : byteio -> int list -> byteio
	
	(* take and drop bits from input *)
	
	val take_bytes : byteio -> int -> int list
	
	val drop_bytes : byteio -> int -> byteio
	
	val take_zero_string : byteio -> string
	
	val drop_zero_string : byteio -> byteio
	
	val take_bits : byteio -> int -> bool list
	
	val drop_bits : byteio -> int -> byteio
	
	val drop_to_byte : byteio -> byteio
	
	val get_fixed : int -> byteio -> int * byteio
		
	(* self test *)
	val tests: bool list  
	 
end
