signature Gzip =
sig

	val get_header : DeflateBits.byteio -> (int * string option * string option * int) * DeflateBits.byteio
	(* get header info from gzip file (date,name,comment,os) *)
	
	val get_trailer : DeflateBits.byteio -> (int * int) * DeflateBits.byteio
	(* get trailer after compressed block (crc, isize) *)
	
	val unzip_io : DeflateBits.byteio -> DeflateBits.byteio
	(* unzip on an IO block, output of result contains uncompressed file *)
	
	val unzip_string : string -> string
	(* unzip .gz file included in a string, return uncompressed file in string *)
	
end
